//
//  SNGCardCreditDetailVC.swift
//  Nextgen Dev
//
//  Created by annguyen on 12/23/20.
//  Copyright © 2020 Chinh.nd. All rights reserved.
//

import Foundation
import UIKit

enum TTHD {
    case EACHTIME
    case RECURRENT
    case NONE
}

class SNGPayEachTimeConfirmVC: SNGBaseViewController{
    @IBOutlet weak var header: SNGHead!
    @IBOutlet weak var colView: UICollectionView!
    @IBOutlet weak var stackView: UIStackView!
    @IBOutlet weak var btnEdit: SNGButton!
    @IBOutlet weak var btnConfirm: SNGButton!
    @IBOutlet weak var vAccount: SNGTransferAccountCell!
    private  let viewModelCard = SNGCardVM()
    private let viewModelSoftOTP = SNGSoftOTPVM()
    var data: [SNGComboboxModel] = []
    var account: SNGAccountModel?
    var transactionData: SNGBillTransactionModel?
    var type: TTHD = .NONE
    override func viewDidLoad() {
        super.viewDidLoad()
        self.configView()
        self.registerCell()
        self.loadData()
        self.loadColView()
    }
    func configView(){
        header.lbTitle.text = "card.detail.title".localized()
        header.selectBack = {
            self.backViewController()
        }
        self.vAccount.title.text = "transfer.label.detail.fromAcc".localized()
        self.vAccount.title.textColor = UIColor.colorFromHex("7b7b7b")
    }
    
    func loadData(){
        
//        self.viewModelSoftOTP.completionSuccess = { [weak self] message in
//            guard let `self` = self else { return }
//            DispatchQueue.main.async { [weak self] in
//                guard let `self` = self else {return}
//                if message == "GET_CHALLENGECODE_SUCCESS" {
//                    if self.viewModelSoftOTP._challengeCode != nil {
//                        let cardData = SNGSoftOTPCardModel()
//                            cardData.cardNumber = self.card!.cardNumber!
//                            cardData.tokenCard = self.card!.tokenCard!
//                            cardData.fromAccount = self.account!.accountID
//                            cardData.amount = self.amount.replacingOccurrences(of: ",", with: "")
//                            cardData.ccy = self.currency
//                            cardData.priority = self.priority
//                            cardData.transactionType = "FT_CARD"
//                            cardData.otpTransactionId = self.viewModelSoftOTP._challengeCode!.transactionId
//                        if self.viewModelSoftOTP._challengeCode!.approvalMethod == "SOFTOTP" {
//                            if Global.isSoftOTPDevice {
//                                let storyboard = UIStoryboard(name: "SNGConfirmPINSoftOTP", bundle: nil)
//                                let viewController = storyboard.instantiateViewController(withIdentifier: "SNGConfirmPINSoftOTP") as! SNGConfirmPINSoftOTPVC
//                                viewController.chalengCode = self.viewModelSoftOTP._challengeCode!.challenge
//                                viewController.transactionId = self.viewModelSoftOTP._challengeCode!.transactionId
//                                viewController.typeTransaction = .CARD
//                                viewController.cardData = cardData
//                                self.navigationController?.pushViewController(viewController, animated: true)
//                            } else {
//                                let agreeAction = Action(with: "Global.Agree".localized(), style: .normalRed) {[weak self] in
//                                    guard self != nil else {return}
//                                }
//        self.showPopupTemplate(title: "settings.softotp.notsetup.title".localized(), content: "settings.softotp.notsetup.des".localized() , actions: [agreeAction], axis: .vertical)
//                            }
//                        } else {
//                            let storyboard = UIStoryboard(name: "SNGConfirmOTPFromSMS", bundle: nil)
//                            let viewController = storyboard.instantiateViewController(withIdentifier: "SNGConfirmOTPFromSMS") as! SNGConfirmOTPFromSMSVC
//                            viewController.typeTransaction = .CARD
//                            viewController.transactionId = self.viewModelSoftOTP._challengeCode!.transactionId
//                            viewController.cardData = cardData
//                            self.navigationController?.pushViewController(viewController, animated: true)
//                        }
//                    }
//                }
//            }
//        }
//        self.viewModelSoftOTP.completionFailed = { [weak self] message in
//            guard let `self` = self else { return }
//            DispatchQueue.main.async {
//                self.showError(error: message)
//            }
//        }
        
    }
    func loadColView(){
        self.data = []
        vAccount.icDropDown.isHidden = true
        if let account = self.account {
            self.vAccount.setData(account)
        }
        if let transaction = self.transactionData {
            switch type {
            case .EACHTIME:
                self.data.append(SNGComboboxModel(id: "Loại hoá đơn", text: transaction.serviceName))
                self.data.append(SNGComboboxModel(id: "Nhà cung cấp", text: transaction.providerName))
                self.data.append(SNGComboboxModel(id: "Mã HĐ/Mã KH", text: transaction.billNo))
                self.data.append(SNGComboboxModel(id: "Tên khách hàng", text: transaction.benName))
                self.data.append(SNGComboboxModel(id: "Địa chỉ khách hàng", text: transaction.address))
                self.data.append(SNGComboboxModel(id: "Số tiền", text: transaction.amount))
                self.data.append(SNGComboboxModel(id: "Nội dung", text: transaction.content))
                self.data.append(SNGComboboxModel(id: "Ngày thực hiện", text: transaction.transDate))
            case .RECURRENT:
                self.data.append(SNGComboboxModel(id: "Loại hoá đơn", text: transaction.serviceName))
                self.data.append(SNGComboboxModel(id: "Nhà cung cấp", text: transaction.providerName))
                self.data.append(SNGComboboxModel(id: "Mã HĐ/Mã KH", text: transaction.billNo))
                self.data.append(SNGComboboxModel(id: "Tên khách hàng", text: transaction.benName))
                self.data.append(SNGComboboxModel(id: "Địa chỉ khách hàng", text: transaction.address))
                self.data.append(SNGComboboxModel(id: "Chu kỳ thực hiện", text: transaction.period))
                self.data.append(SNGComboboxModel(id: "Nội dung", text: transaction.content))
                self.data.append(SNGComboboxModel(id: "Ngày thực hiện", text: transaction.createDate))
                self.data.append(SNGComboboxModel(id: "Ngày hiệu lực", text: transaction.valueDate))
                self.data.append(SNGComboboxModel(id: "Ngày kết thúc", text: transaction.endDate))
                self.data.append(SNGComboboxModel(id: "Ưu tiên duyệt", text: priority(transaction.priority)))
            default:
                break
            }
        }
       
        colView.reloadData()
    }
    func priority(_ bool: Bool) -> String {
        if bool {
            return "Có"
        } else {
            return "Không"
        }
    }
    func registerCell() {
        colView.register(UINib(nibName: SNGCollectionViewCellDetail.className, bundle: nil),
                         forCellWithReuseIdentifier: SNGCollectionViewCellDetail.className)
    }
    
    @IBAction func onEditTouch(_ sender: Any) {
        self.backViewController()
    }
    
    
    @IBAction func onConfirmTouch(_ sender: Any) {
//        self.bill
//        self.viewModelSoftOTP.getChallengeCode(transType: "CARD", accountNo: "", cardNo: self.card!.tokenCard!)
    }
    
}
extension SNGPayEachTimeConfirmVC: UICollectionViewDelegate {
    
}

extension SNGPayEachTimeConfirmVC: UICollectionViewDataSource {
    
    func collectionView(_ collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        return self.data.count
    }
    
    func collectionView(_ collectionView: UICollectionView, cellForItemAt indexPath: IndexPath) -> UICollectionViewCell {
        // Collection Overdraft Account
        let cell = collectionView.dequeueReusableCell(withReuseIdentifier: SNGCollectionViewCellDetail.className, for: indexPath) as! SNGCollectionViewCellDetail
        cell.key.text = data[indexPath.row].id.localized()
        cell.value.text = data[indexPath.row].text
        if data[indexPath.row].id == "card.balance.amount" {
            cell.value.textColor = UIColor.colorFromHex("d71424")
        } else {
            cell.value.textColor = UIColor.colorFromHex("000000")
        }
        return cell
    }
}

// set style
extension SNGPayEachTimeConfirmVC: UICollectionViewDelegateFlowLayout {
    func collectionView(_ collectionView: UICollectionView,
                        layout collectionViewLayout: UICollectionViewLayout,
                        sizeForItemAt indexPath: IndexPath) -> CGSize {
        return CGSize(width: self.view.frame.width , height: 56.5)
    }
    
    func collectionView(_ collectionView: UICollectionView,
                        layout collectionViewLayout: UICollectionViewLayout,
                        minimumLineSpacingForSectionAt section: Int) -> CGFloat {
        return 0
    }
}

